#include <bits/stdc++.h>
#define st first
#define nd second
#define fi first
#define se second
#define pb push_back
#define ps(v) cout << v << " "
#define pln(v) cout << v << "\n"
#define entr cout << "\n"

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;


/*
int solve(int n, string a) {
	string c;
	for (int i = 0; i < n; i++) {
		c.push_back(a[i]);
		c.push_back('#');
	}
	c.push_back('$');
	int s = c.size(); vector <int> P(s);
	for (int i = 0, k = 0; i < s; i++) {
		if (k+P[k] > i) {
			P[i] = max(1, min(P[2*k-i], k+P[k]-i));
		}
		while (P[i] <= i && c[i+P[i]] == c[i-P[i]]) {
			P[i]++;
		}
		if (i+P[i] > k+P[k]) {
			k = i;
		}
		//cout << P[i] << " ";
	}
	//cout <<endl;
	int ans = n-1;
	//cout << s <<endl;
	for (int i = 0; i < s-1; i++) {
		//cout << i << " " << i+P[i] << " " << s <<endl;
		if (c[i] == '#') {
			//cout << i << " " << c[i] << " " << i+P[i] << " " << (i-P[i]+2)/2 <<endl;
			if (i+P[i] >= s-2) {
				ans = min(ans, (i-P[i]+2) / 2);
			} 
		}
		else {
			//cout << i << " " << c[i] << " " << i+P[i] << " " << (i-P[i]+2)/2 <<endl;
			if (i+P[i] >= s-1) {
				ans = min(ans, (i-P[i] + 2) / 2);
			} 
		}
		//cout << ans <<endl;
	}
	return ans;
}
*/

void manacher(string w, int n, vector <int> &P, int sh) {
	int g = 0;
	P[0] = 1 - sh;
	for (int i = 1; i < n; i++) {
		P[i] = (2*g-i > 0) ? max(min(P[2*g-i], P[g]+g-i), 0) : 0;
		while (i >= P[i]+sh && i+P[i] < n && w[i+P[i]] == w[i-P[i]-sh]) {
			P[g=i]++;
		}
	}
}


int solve(int n, string a) {
	a.push_back('$');
	vector <int> P1(n+1), P2(n+1);
	manacher(a, n, P1, 0);
	manacher(a, n, P2, 1);
	int ans = n-1;
	//cout << s <<endl;
	for (int i = 0; i < n; i++) {
		//cout << i << " " << a[i] << " " << i+P1[i] << " " << i-P1[i]+1 <<endl;
		if (i+P1[i] >= n) {
			ans = min(ans, i-P1[i]+1);
		} 
		//cout << ans <<endl;
	}
	//cout << s <<endl;
	for (int i = 0; i < n; i++) {
		//cout << i << " " << a[i] << " " << i+P2[i] << " " << i-P2[i] <<endl;
		if (i+P2[i] >= n) {
			ans = min(ans, i-P2[i]);
		} 
		//cout << ans <<endl;
	}
	return ans;
}


int main() {
	ios_base::sync_with_stdio(0);
	int n; string a;
	cin >> n >> a;
	int ans = solve(n, a);
	cout << ans <<endl;
	return 0;
}
